# Class SubSublayerExtensionCollection

A collection of sublayer extensions belonging to a SublayerExtension.

#### Hierarchy (view full)

- SublayerExtensionCollectionBase
  - SubSublayerExtensionCollection

#####
Index

### Constructors

constructor

### Properties

_parent
@eventTypes
declaredClass

### Accessors

_collection
_layerExtension
destroyed
initialized
initializedItems
length

### Methods

_get
_itemIsInitialized
_onAdded
_onRemoved
_set
[iterator]
add
addHandles
addMany
at
clone
concat
destroy
destroyAll
destroyMany
drain
every
filter
find
findById
findBySublayerId
findIndex
flatten
forEach
forSublayer
get
getItemAt
hasHandles
includes
indexOf
join
lastIndexOf
map
notifyChange
on
onLayerExtensionChanged
onParentInitialized
pop
push
reduce
reduceRight
remove
removeAll
removeAt
removeHandles
removeMany
reorder
reverse
set
shift
slice
some
sort
splice
toArray
unshift
watch

##
Constructors

### constructor

- new SubSublayerExtensionCollection(parent, sublayersProperty?): SubSublayerExtensionCollection

- #### Parameters

  - parent: SublayerExtension<SublayerExtensionProperties>
  - `Optional` sublayersProperty: string

  #### Returns SubSublayerExtensionCollection

  Overrides SublayerExtensionCollectionBase.constructor

##
Properties

### `Protected` `Readonly`_parent

_parent: SublayerExtension<SublayerExtensionProperties>

The SublayerExtension that owns this collection.

Overrides SublayerExtensionCollectionBase._parent

### @eventTypes

@eventTypes: CollectionEvents<SublayerExtension<SublayerExtensionProperties>>

#### Deprecated

Do not directly reference this property. Use EventNames and EventTypes helpers from @arcgis/core/Evented.

Inherited from SublayerExtensionCollectionBase.@eventTypes

### declaredClass

declaredClass: string = "esri.core.Collection"

The declared class name. This is always `"esri.core.Collection"` for compatibility with Esri's API.

Inherited from SublayerExtensionCollectionBase.declaredClass

##
Accessors

### `Protected`_collection

- get _collection(): Collection<SublayerExtension<SublayerExtensionProperties>>

- The underlying collection that this class delegates to.

  #### Returns Collection<SublayerExtension<SublayerExtensionProperties>>

  Inherited from SublayerExtensionCollectionBase._collection

### `Protected`_layerExtension

- get _layerExtension(): LayerExtension<LayerExtensionProperties>

- The layer extension that the collection of sublayers is associated with.

  #### Returns LayerExtension<LayerExtensionProperties>

  Overrides SublayerExtensionCollectionBase._layerExtension

### destroyed

- get destroyed(): boolean

- Whether the collection has been destroyed.

  #### Returns boolean

  Inherited from SublayerExtensionCollectionBase.destroyed

- set destroyed(value): void

- #### Parameters

  - value: boolean

  #### Returns void

  Inherited from SublayerExtensionCollectionBase.destroyed

### initialized

- get initialized(): boolean

- Whether the collection has been initialized.

  #### Returns boolean

  Inherited from SublayerExtensionCollectionBase.initialized

- set initialized(value): void

- Set to `true` once the initialize function has executed.

  #### Parameters

  - value: boolean

  #### Returns void

  Inherited from SublayerExtensionCollectionBase.initialized

### initializedItems

- get initializedItems(): ReadOnlyCollection<T>

- Returns a collection of the initialized items.

  #### Returns ReadOnlyCollection<T>

  Inherited from SublayerExtensionCollectionBase.initializedItems

### length

- get length(): number

- The number of items in the collection.

  #### Returns number

  Inherited from SublayerExtensionCollectionBase.length

##
Methods

### `Protected`_get

- _get(propertyName): any

- #### Parameters

  - propertyName: string

  #### Returns any

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Inherited from SublayerExtensionCollectionBase._get

- _get<T>(propertyName): T

- #### Type Parameters

  - T

  #### Parameters

  - propertyName: string

  #### Returns T

  Inherited from SublayerExtensionCollectionBase._get

### `Protected`_itemIsInitialized

- _itemIsInitialized(item): boolean

- Returns whether an item in the collection is considered initialized.

  #### Parameters

  - item: SublayerExtension<SublayerExtensionProperties>

    The item being checked for initialization.

  #### Returns boolean

  Inherited from SublayerExtensionCollectionBase._itemIsInitialized

### `Protected`_onAdded

- _onAdded(sublayerExtension): void

- Invoked whenever a sublayer extension is added.

  #### Parameters

  - sublayerExtension: SublayerExtension<SublayerExtensionProperties>

    The new sublayer extension.

  #### Returns void

  Overrides SublayerExtensionCollectionBase._onAdded

### `Protected`_onRemoved

- _onRemoved(sublayerExtension): void

- Invoked whenever a sublayer extension is removed.

  #### Parameters

  - sublayerExtension: SublayerExtension<SublayerExtensionProperties>

    The sublayer extension that was removed.

  #### Returns void

  Overrides SublayerExtensionCollectionBase._onRemoved

### `Protected`_set

- _set<T>(propertyName, value): this

- #### Type Parameters

  - T

  #### Parameters

  - propertyName: string
  - value: T

  #### Returns this

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Inherited from SublayerExtensionCollectionBase._set

### [iterator]

- [iterator](): IterableIterator<SublayerExtension<SublayerExtensionProperties>, any, any>

- #### Returns IterableIterator<SublayerExtension<SublayerExtensionProperties>, any, any>

  #### Inherit Doc

  Inherited from SublayerExtensionCollectionBase.[iterator]

### add

- add(sublayerX, index?): this

- Adds a single item to the collection.

  #### Parameters

  - sublayerX: SublayerExtension<SublayerExtensionProperties>
  - `Optional` index: number

    Zero-based index of where in the collection to add the item. If not specified, the items will be added at the end.

  #### Returns this

  Overrides SublayerExtensionCollectionBase.add

### addHandles

- addHandles<T>(handles, groupKey?): void

- Adds one or more handles which are to be tied to the lifecycle of the object. The handles will be removed when the object is destroyed.

      // Manually manage handles
      const handle = reactiveUtils.when(
        () => !view.updating,
        () => {
          wkidSelect.disabled = false;
        },
        { once: true }
      );

      this.addHandles(handle);

      // Destroy the object
      this.destroy();

  #### Type Parameters

  - T

  #### Parameters

  - handles: IHandle | IHandle[]
  - `Optional` groupKey: Exclude<T, ResourceHandle>

    Key identifying the group to which the handles should be added. All the handles in the group can later be removed with removeHandles(). If no key is provided the handles are added to a default group.

  #### Returns void

  #### Since

  4.25

  Inherited from SublayerExtensionCollectionBase.addHandles

### addMany

- addMany(items, index?): this

- Adds multiple items to the collection.

  #### Parameters

  - items: ReadonlyArrayOrCollection<SublayerExtension<SublayerExtensionProperties>>

    An array or collection of items to add.

  - `Optional` index: number

    Zero-based index of where in the collection to add the items. If not specified, the items will be added at the end.

  #### Returns this

  Inherited from SublayerExtensionCollectionBase.addMany

### at

- at(index): SublayerExtension<SublayerExtensionProperties>

- Returns the item at the specified index.

  #### Parameters

  - index: number

    Zero-based index of the item in the Collection to retrieve.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  The item in the Collection stored at the specified index.

  Inherited from SublayerExtensionCollectionBase.at

### clone

- clone(): SublayerExtensionCollectionBase

- Creates a deep clone of the Collection. To create a shallow clone of the collection, use slice().

  #### Returns SublayerExtensionCollectionBase

  Inherited from SublayerExtensionCollectionBase.clone

### concat

- concat(value): Collection<SublayerExtension<SublayerExtensionProperties>>

- Creates a new Collection containing the items in the original Collection joined with the items in the input array or Collection.

  #### Parameters

  - value: Collection<SublayerExtension<SublayerExtensionProperties>> | SublayerExtension<SublayerExtensionProperties>[]

    The array or Collection to append to the existing Collection.

  #### Returns Collection<SublayerExtension<SublayerExtensionProperties>>

  Inherited from SublayerExtensionCollectionBase.concat

### destroy

- destroy(): void

- Removes all event listeners and destroys the collection.

  #### Returns void

  Inherited from SublayerExtensionCollectionBase.destroy

### destroyAll

- destroyAll(): void

- #### Returns void

  #### Inherit Doc

  Inherited from SublayerExtensionCollectionBase.destroyAll

### destroyMany

- destroyMany(items): SublayerExtension<SublayerExtensionProperties>[]

- #### Parameters

  - items: ReadonlyArrayOrCollection<SublayerExtension<SublayerExtensionProperties>>

  #### Returns SublayerExtension<SublayerExtensionProperties>[]

  #### Inherit Doc

  Inherited from SublayerExtensionCollectionBase.destroyMany

### drain

- drain(callback, thisArg?): void

- #### Parameters

  - callback: ItemCallback<SublayerExtension<SublayerExtensionProperties>>
  - `Optional` thisArg: any

  #### Returns void

  #### Inherit Doc

  Inherited from SublayerExtensionCollectionBase.drain

### every

- every(callback): boolean

- Determines whether all items in the Collection pass a test defined by callback. Each item in the Collection is passed into the callback until one returns a value of false.

  #### Parameters

  - callback: ItemTestCallback<SublayerExtension<SublayerExtensionProperties>>

    The function to call for each item in the Collection.

  #### Returns boolean

  Inherited from SublayerExtensionCollectionBase.every

### filter

- filter(callback): Collection<SublayerExtension<SublayerExtensionProperties>>

- Filters the Collection's items based on a test defined by the callback function. Each item is passed into the callback function, which returns true if the item passes the test and false if it does not.

  #### Parameters

  - callback: ItemTestCallback<SublayerExtension<SublayerExtensionProperties>>

    The function that defines a test for determining whether to return the item in a new Collection.

  #### Returns Collection<SublayerExtension<SublayerExtensionProperties>>

  Inherited from SublayerExtensionCollectionBase.filter

### find

- find(callback): SublayerExtension<SublayerExtensionProperties>

- Returns an item in the Collection if that item passes a test as defined in the callback function. Each item is passed into the callback function, which returns true if the item passes the test and false if it does not.

  #### Parameters

  - callback: ItemTestCallback<SublayerExtension<SublayerExtensionProperties>>

    The testing function that will assess each item in the Collection. Returns true if an item passes the test and false if it fails.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  Inherited from SublayerExtensionCollectionBase.find

### findById

- findById(id): SublayerExtension<SublayerExtensionProperties>

- Get the sublayer extension for a given id.

  #### Parameters

  - id: string

    The id of the sublayer extension.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  The sublayer extension.

  Inherited from SublayerExtensionCollectionBase.findById

### findBySublayerId

- findBySublayerId(id): SublayerExtension<SublayerExtensionProperties>

- Get the corresponding sublayer extension for a given sublayer id.

  #### Parameters

  - id: string | number

    The id of the sublayer.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  The corresponding sublayer extension.

  Inherited from SublayerExtensionCollectionBase.findBySublayerId

### findIndex

- findIndex(callback): number

- Returns the index of an item in the Collection if that item passes a test as defined in the callback function. Each item is passed into the callback function, which returns true if the item passes the test and false if it does not.

  #### Parameters

  - callback: ItemTestCallback<SublayerExtension<SublayerExtensionProperties>>

    The testing function that will assess each item in the Collection. Returns true if an item passes the test and false if it fails.

  #### Returns number

  Returns the index of the Collection item that satisfies the test function. If an item fails the test, -1 is returned.

  Inherited from SublayerExtensionCollectionBase.findIndex

### flatten

- flatten(callback): Collection<SublayerExtension<SublayerExtensionProperties>>

- Flattens a hierarchical Collection containing at least one child collection. Each item in the collection is passed into the callback function, which should check for child collections specified by the developer. A flat collection of all items (parent and children) is returned.

  #### Parameters

  - callback: ((item: SublayerExtension<SublayerExtensionProperties>, index: number) => Collection<SublayerExtension<SublayerExtensionProperties>> | SublayerExtension<SublayerExtensionProperties>[])

    A function that will assess each item in the Collection.

    - - (item, index): Collection<SublayerExtension<SublayerExtensionProperties>> | SublayerExtension<SublayerExtensionProperties>[]

      - #### Parameters

        - item: SublayerExtension<SublayerExtensionProperties>
        - index: number

        #### Returns Collection<SublayerExtension<SublayerExtensionProperties>> | SublayerExtension<SublayerExtensionProperties>[]

  #### Returns Collection<SublayerExtension<SublayerExtensionProperties>>

  Inherited from SublayerExtensionCollectionBase.flatten

### forEach

- forEach(callback): void

- Executes the input function for each item in the Collection.

  #### Parameters

  - callback: ItemCallback<SublayerExtension<SublayerExtensionProperties>>

    The function to call for each item in the Collection.

  #### Returns void

  Inherited from SublayerExtensionCollectionBase.forEach

### forSublayer

- forSublayer(sublayer): SublayerExtension<SublayerExtensionProperties>

- Gets the corresponding sublayer extension for a given sublayer.

  #### Parameters

  - sublayer: SublayerLike

    A sublayer.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  The corresponding sublayer extension.

  Inherited from SublayerExtensionCollectionBase.forSublayer

### get

- get<T>(propertyPath): T

- #### Type Parameters

  - T

  #### Parameters

  - propertyPath: string

  #### Returns T

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Inherited from SublayerExtensionCollectionBase.get

- get(propertyPath): unknown

- #### Parameters

  - propertyPath: string

  #### Returns unknown

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Inherited from SublayerExtensionCollectionBase.get

### getItemAt

- getItemAt(index): SublayerExtension<SublayerExtensionProperties>

- Returns the item at the specified index.

  #### Parameters

  - index: number

    Zero-based index of the item in the Collection to retrieve.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  The item in the Collection stored at the specified index.

  Inherited from SublayerExtensionCollectionBase.getItemAt

### hasHandles

- hasHandles<T>(groupKey?): boolean

- Returns true if a named group of handles exist.

  #### Type Parameters

  - T

  #### Parameters

  - `Optional` groupKey: Exclude<T, ResourceHandle>

    A group key.

  #### Returns boolean

  Returns `true` if a named group of handles exist.

  #### Since

  4.25

  #### Example

      // Remove a named group of handles if they exist.
      if (obj.hasHandles("watch-view-updates")) {
        obj.removeHandles("watch-view-updates");
      }

  Inherited from SublayerExtensionCollectionBase.hasHandles

### includes

- includes(searchElement): boolean

- Tests if an item is present in the Collection.

  #### Parameters

  - searchElement: SublayerExtension<SublayerExtensionProperties>

    The item to search for in the collection.

  #### Returns boolean

  Inherited from SublayerExtensionCollectionBase.includes

### indexOf

- indexOf(searchElement, fromIndex?): number

- Returns the index of an element in the collection.

  #### Parameters

  - searchElement: SublayerExtension<SublayerExtensionProperties>

    Item to search for in the collection.

  - `Optional` fromIndex: number

    Use if you don't want to search the whole collection or you don't want to search from the start.

  #### Returns number

  Inherited from SublayerExtensionCollectionBase.indexOf

### join

- join(separator?): string

- Creates a string representation of the items in the Collection.

  #### Parameters

  - `Optional` separator: string

    The separator used between each item in the final string. The default is ",".

  #### Returns string

  Inherited from SublayerExtensionCollectionBase.join

### lastIndexOf

- lastIndexOf(searchElement, fromIndex?): number

- Returns the last index of an element in the collection.

  #### Parameters

  - searchElement: SublayerExtension<SublayerExtensionProperties>

    Item to search for in the collection.

  - `Optional` fromIndex: number

    Use if you don't want to search the whole collection, or you don't want to search from the end.

  #### Returns number

  The location of the last match found in the collection, or -1 if there is no match.

  Inherited from SublayerExtensionCollectionBase.lastIndexOf

### map

- map<U>(callback): Collection<U>

- Passes each Collection item into the callback function and returns a new array of the returned values.

  #### Type Parameters

  - U

  #### Parameters

  - callback: ItemMapCallback<SublayerExtension<SublayerExtensionProperties>, U>

    The function that processes each item in the Collection and returns a new value at the same index of the original item.

  #### Returns Collection<U>

  Inherited from SublayerExtensionCollectionBase.map

### `Protected` notifyChange

- notifyChange(propertyKey): void

- #### Parameters

  - propertyKey: string

  #### Returns void

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Inherited from SublayerExtensionCollectionBase.notifyChange

- notifyChange(propertyKey): void

- #### Parameters

  - propertyKey: keyof SubSublayerExtensionCollection

  #### Returns void

  Inherited from SublayerExtensionCollectionBase.notifyChange

### on

- on<Type>(eventName, listener): ResourceHandle

- Registers an event handler on the instance. Call this method to hook an event with a listener.

  #### Type Parameters

  - Type extends EventNames<SubSublayerExtensionCollection>

  #### Parameters

  - eventName: Type
  - listener: EventedCallback<CollectionEvents<SublayerExtension<SublayerExtensionProperties>>[Type]>

    The function to call when the event fires.

  #### Returns ResourceHandle

  Returns an event handler with a `remove()` method that should be called to stop listening for the event(s).

  Property | Type | Description
  --- | --- | ---
  remove | Function | When called, removes the listener from the event.

  #### Example

      view.on("click", function(event){
        // event is the event handle returned after the event fires.
        console.log(event.mapPoint);
      });

  Inherited from SublayerExtensionCollectionBase.on

### onLayerExtensionChanged

- onLayerExtensionChanged(): void

- Invoked by the parent whenever the associated layer extension is updated.

  #### Returns void

  Inherited from SublayerExtensionCollectionBase.onLayerExtensionChanged

### onParentInitialized

- onParentInitialized(): void

- Invoked by the parent object when it is initialized.

  #### Returns void

  Inherited from SublayerExtensionCollectionBase.onParentInitialized

### pop

- pop(): SublayerExtension<SublayerExtensionProperties>

- Removes the last item from the collection and returns it.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  Inherited from SublayerExtensionCollectionBase.pop

### push

- push(item): number

- Adds an item to the end of the collection.

  #### Parameters

  - item: SublayerExtension<SublayerExtensionProperties>

    The item to add.

  #### Returns number

  Inherited from SublayerExtensionCollectionBase.push

### reduce

- reduce<U>(callback, initialValue?): U

- Reduces all items in the collection (from left to right) into a single variable using callback.

  #### Type Parameters

  - U

  #### Parameters

  - callback: ItemReduceCallback<SublayerExtension<SublayerExtensionProperties>, U>

    The function that processes each item in the Collection and appends it to the previous item.

  - `Optional` initialValue: U

    Item to use as the first element to process in callback.

  #### Returns U

  Inherited from SublayerExtensionCollectionBase.reduce

### reduceRight

- reduceRight<U>(callback, initialValue?): U

- Reduces all items in the collection (from right to left) into a single variable using callback.

  #### Type Parameters

  - U

  #### Parameters

  - callback: ItemReduceCallback<SublayerExtension<SublayerExtensionProperties>, U>

    The function that processes each item in the Collection and appends it to the previous item.

  - `Optional` initialValue: U

    Item to use as the first element to process in callback.

  #### Returns U

  Inherited from SublayerExtensionCollectionBase.reduceRight

### remove

- remove(item): SublayerExtension<SublayerExtensionProperties>

- Removes an item from the collection.

  #### Parameters

  - item: SublayerExtension<SublayerExtensionProperties>

    The item to remove.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  Inherited from SublayerExtensionCollectionBase.remove

### removeAll

- removeAll(): SublayerExtension<SublayerExtensionProperties>[]

- Removes all items from the collection.

  #### Returns SublayerExtension<SublayerExtensionProperties>[]

  Inherited from SublayerExtensionCollectionBase.removeAll

### removeAt

- removeAt(index): SublayerExtension<SublayerExtensionProperties>

- Removes an item from the collection at a specified index.

  #### Parameters

  - index: number

    The index of the element to remove.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  Inherited from SublayerExtensionCollectionBase.removeAt

### removeHandles

- removeHandles<T>(groupKey?): void

- Removes a group of handles owned by the object.

  #### Type Parameters

  - T

  #### Parameters

  - `Optional` groupKey: Exclude<T, ResourceHandle>

    A group key or an array or collection of group keys to remove.

  #### Returns void

  #### Since

  4.25

  #### Example

      obj.removeHandles(); // removes handles from default group

      obj.removeHandles("handle-group");
      obj.removeHandles("other-handle-group");

  Inherited from SublayerExtensionCollectionBase.removeHandles

### removeMany

- removeMany(items): SublayerExtension<SublayerExtensionProperties>[]

- Removes each item in the input array. If an item is present multiple times in the collection, only the first occurrence is removed.

  #### Parameters

  - items: ReadonlyArrayOrCollection<SublayerExtension<SublayerExtensionProperties>>

    The items to remove.

  #### Returns SublayerExtension<SublayerExtensionProperties>[]

  Inherited from SublayerExtensionCollectionBase.removeMany

### reorder

- reorder(sublayerX, index): SublayerExtension<SublayerExtensionProperties>

- Moves an item in the Collection to a specified index. The change event is fired after an item is moved in the Collection.

  #### Parameters

  - sublayerX: SublayerExtension<SublayerExtensionProperties>
  - index: number

    The index to move the item to.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  Inherited from SublayerExtensionCollectionBase.reorder

### reverse

- reverse(): this

- Reverses the collection in place.

  #### Returns this

  Inherited from SublayerExtensionCollectionBase.reverse

### set

- set<T>(propertyPath, value): this

- #### Type Parameters

  - T

  #### Parameters

  - propertyPath: string
  - value: T

  #### Returns this

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Inherited from SublayerExtensionCollectionBase.set

- set(properties): this

- #### Parameters

  - properties: HashMap<unknown>

  #### Returns this

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Inherited from SublayerExtensionCollectionBase.set

### shift

- shift(): SublayerExtension<SublayerExtensionProperties>

- Removes the first item from the collection (at index 0), and returns it. The remaining items of the collection are then shifted down one index from their previous location.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  Inherited from SublayerExtensionCollectionBase.shift

### slice

- slice(begin?, end?): Collection<SublayerExtension<SublayerExtensionProperties>>

- Creates a new Collection comprised of a portion of the original Collection.

  #### Parameters

  - `Optional` begin: number

    The index of the first item to extract.

  - `Optional` end: number

    The index of the last item to extract.

  #### Returns Collection<SublayerExtension<SublayerExtensionProperties>>

  Inherited from SublayerExtensionCollectionBase.slice

### some

- some(callback): boolean

- Determines whether an item in the Collection passes a test defined by callback. Each item in the Collection is passed into the callback until one returns a value of true.

  #### Parameters

  - callback: ItemTestCallback<SublayerExtension<SublayerExtensionProperties>>

    The function that defines the test for each Collection item.

  #### Returns boolean

  Inherited from SublayerExtensionCollectionBase.some

### sort

- sort(compareFunction?): this

- Sorts the Collection in place.

  #### Parameters

  - `Optional` compareFunction: ((a: SublayerExtension<SublayerExtensionProperties>, b: SublayerExtension<SublayerExtensionProperties>) => number)

    The function that defines a comparison of two items in the collection.

    - - (a, b): number

      - #### Parameters

        - a: SublayerExtension<SublayerExtensionProperties>
        - b: SublayerExtension<SublayerExtensionProperties>

        #### Returns number

  #### Returns this

  Inherited from SublayerExtensionCollectionBase.sort

### splice

- splice(start, deleteCount, ...items): SublayerExtension<SublayerExtensionProperties>[]

- Removes existing items and/or adds new items to the collection.

  #### Parameters

  - start: number

    Index at which to start changing the collection.

  - deleteCount: number

    Indicates the number of collection items to remove. If 0 is used then no elements are removed and at least one new item should be added in the items parameter.

  - `Rest`...items: SublayerExtension<SublayerExtensionProperties>[]

    The item or comma-separated list of items to add to the collection.

  #### Returns SublayerExtension<SublayerExtensionProperties>[]

  An array of the deleted items formerly part of the collection.

  Inherited from SublayerExtensionCollectionBase.splice

### toArray

- toArray(): SublayerExtension<SublayerExtensionProperties>[]

- Returns a new array object containing the Collection's items.

  #### Returns SublayerExtension<SublayerExtensionProperties>[]

  Inherited from SublayerExtensionCollectionBase.toArray

### unshift

- unshift(item): number

- Adds an item to the beginning of the collection.

  #### Parameters

  - item: SublayerExtension<SublayerExtensionProperties>

    The item to add.

  #### Returns number

  Inherited from SublayerExtensionCollectionBase.unshift

### watch

- watch(path, callback, sync?): IHandle

- #### Parameters

  - path: string | string[]
  - callback: ((newValue: any, oldValue: any, propertyName: string, target: any) => void)
    - - (newValue, oldValue, propertyName, target): void

      - #### Parameters

        - newValue: any
        - oldValue: any
        - propertyName: string
        - target: any

        #### Returns void

  - `Optional` sync: boolean

  #### Returns IHandle

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Inherited from SublayerExtensionCollectionBase.watch